"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _dbArgs = _interopRequireDefault(require("./dbArgs"));

var _apiSecurity = require("@webiny/api-security");

var _apiUpgrade = require("@webiny/api-upgrade");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _default = context => {
  const {
    db
  } = context;

  const keys = () => ({
    PK: `T#${context.tenancy.getCurrentTenant().id}#SYSTEM`,
    SK: "SECURITY"
  });

  return {
    async getVersion() {
      const rootTenant = await context.tenancy.getRootTenant();

      if (!rootTenant) {
        return null;
      }

      const [[system]] = await db.read(_objectSpread(_objectSpread({}, _dbArgs.default), {}, {
        query: keys()
      }));
      return system ? system.version : null;
    },

    async setVersion(version) {
      const [[system]] = await db.read(_objectSpread(_objectSpread({}, _dbArgs.default), {}, {
        query: keys()
      }));

      if (system) {
        await db.update(_objectSpread(_objectSpread({}, _dbArgs.default), {}, {
          query: keys(),
          data: {
            version
          }
        }));
      } else {
        await db.create(_objectSpread(_objectSpread({}, _dbArgs.default), {}, {
          data: _objectSpread(_objectSpread({}, keys()), {}, {
            version
          })
        }));
      }
    },

    async upgrade(version) {
      const identity = context.security.getIdentity();

      if (!identity) {
        throw new _apiSecurity.NotAuthorizedError();
      }

      const upgradePlugins = context.plugins.byType("api-upgrade").filter(pl => pl.app === "security");
      const plugin = (0, _apiUpgrade.getApplicablePlugin)({
        deployedVersion: context.WEBINY_VERSION,
        installedAppVersion: await this.getVersion(),
        upgradePlugins,
        upgradeToVersion: version
      });
      await plugin.apply(context); // Store new app version

      await this.setVersion(version);
      return true;
    }

  };
};

exports.default = _default;
//# sourceMappingURL=system.crud.js.map