"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

const emptyResolver = () => ({});

const plugin = {
  type: "graphql-schema",
  name: "graphql-schema-security-base",
  schema: {
    typeDefs: `
            type SecurityQuery {
                _empty: String
            }

            type SecurityMutation {
                _empty: String
            }

            extend type Query {
                security: SecurityQuery
            }

            extend type Mutation {
                security: SecurityMutation
            }
            
            type SecurityCreatedBy {
                id: ID
                displayName: String
            }

            type SecurityError {
                code: String
                message: String
                data: JSON
            }

            type SecurityBooleanResponse {
                data: Boolean
                error: SecurityError
            }
        `,
    resolvers: {
      Query: {
        security: emptyResolver
      },
      Mutation: {
        security: emptyResolver
      }
    }
  }
};
var _default = plugin;
exports.default = _default;
//# sourceMappingURL=base.gql.js.map